package TTXMarkup;
#
# Markup language pack/upack routines
#
# This module is a part of Trouble Ticket Express package
# http://www.troubleticketexpress.com
#
# COPYRIGHT: 2004-2005, United Web Coders
# http://www.unitedwebcoders.com
#
# $Revision: 63 $
# $Date: 2005-11-22 00:46:39 -0500 (Tue, 22 Nov 2005) $
#
#
$TTXMarkup::VERSION='2.20';
BEGIN {
  $TTXMarkup::REVISION = '$Revision: 63 $';
  if ($TTXMarkup::REVISION =~ /(\d+)/) {
    $TTXMarkup::REVISION = $1;
  }
};
use strict;

# ========================================================================= html

sub html {
  my $buff = shift;
  $buff =~ s/\[(\/?)(u|b|i|code)]/<$1$2>/gi; # [b] [i] [u] [code]
  $buff =~ s/\[\(]/[/g; # [[]
  $buff =~ s/\[url\s+([^]\s]+)\s*]/<a href="$1" target=_blank>/gi;
  $buff =~ s/\[\/url\s*]/<\/a>/gi;
  $buff =~ s/\[(image|img)\s+([^]\s]+)\s*]/<img src="$2">/gi;
  $buff =~ s/\[\/(image|img)\s*]/<\/img>/gi;
  $buff =~ s/  /&nbsp; /g;
  return $buff;
}
# ========================================================================= help

sub help {
  return undef;
}
# ======================================================================== strip

sub strip {
  my $buff = shift;
  $buff =~ s/\[(\/?)(u|b|i|code)]//gi; # [b] [i] [u] [code]
  $buff =~ s/\[\(]/[/g; # [[]
  $buff =~ s/\[url\s+([^]\s]+)\s*]/$1 /gi;
  $buff =~ s/\[\/url\s*]/ /gi;
  $buff =~ s/\[(image|img)\s+([^]\s]+)\s*]/$2 /gi;
  $buff =~ s/\[\/(image|img)\s*]//gi;
  return $buff;
}
1;
#
