package TTXTicket;
#
# This module is a part of Trouble Ticket Express package
# http://www.troubleticketexpress.com
#
# COPYRIGHT: 2002-2005, United Web Coders
# http://www.unitedwebcoders.com
#
# $Revision: 87 $
# $Date: 2005-11-25 10:39:43 -0500 (Fri, 25 Nov 2005) $
#

$TTXTicket::VERSION='2.20';
BEGIN {
  $TTXTicket::REVISION = '$Revision: 87 $';
  if ($TTXTicket::REVISION =~ /(\d+)/) {
    $TTXTicket::REVISION = $1;
  }
};

use strict;
use TTXCommon;
require TTXUser;
use TTXTickets;
require TTXMail;
require TTXMarkup;

# =================================================================== usernotify

sub usernotify {
  my $cfg = $_[0]->{cfg};
  return if $cfg->get('_USER') eq undef && $cfg->get('blockautoresponder');
  my $ticket = $_[0]->{ticket};
  my $email = $ticket->{'email'};
  my $name = $ticket->{'name'};
  my %macros;
  $name = 'Customer' if $name eq undef;
  my $subject;
  my $messages = $ticket->{messages};
  my $tmpl;
  if (@{$messages} == 1) {
    $tmpl = 'newticket';
    if ($cfg->get('validate') ne undef) {
      $tmpl .= 'validate';
      $macros{ENV_HTTP_HOST} = $ENV{HTTP_HOST};
      $macros{VALIDATIONCODE} = $_[0]->{validationcode};
    }
  } else {
    $tmpl = 'newmessage';
  }
  if (open(TMPL, $cfg->get('basedir')."/templates/$tmpl.txt")) {
    my @buff = <TMPL>;
    close TMPL;
    $tmpl = join('', @buff);
  }
  $macros{TICKETID} = $ticket->{id};
  $macros{TICKETSTATE} = TTXCommon::status($ticket->{status});
  $macros{UNAME} = $name;
  $macros{COMPANYNAME} = $cfg->get('company');
  $macros{UEMAIL} = $email;
  $macros{OPERATORNAME} = '-';
  $macros{FROM} = $_[0]->{from};
  if ($ticket->{oper} ne undef) {
    my $u = TTXUser->new($ticket->{oper});
    if ($u ne undef) {
      $macros{OPERATORNAME} = $u->{fname}.' '.$u->{lname};
    }
  }
  my $respondername;
  if ($cfg->get('askforname') ne undef) {
    my $nm = $name;
    $nm =~ s/[="'&><]//g;
    $nm =~ s/\s/+/g;
    $respondername = "&respondername=$nm";
  }
  $macros{TICKETURL} = "http://$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}?cmd=ticket&key=".$ticket->{key}.$respondername.
                         "\n\nACCESS KEY: ".$ticket->{key};
  my $msg = $messages->[@{$messages} - 1];
  my @msgparts = split(/\n\n/, $msg);
  shift @msgparts;
  my $body = join("\n\n", @msgparts);
  $body =~s/\[b]//g;
  $body =~s/:\[\/b]/:/g;
  $macros{MESSAGE} = $body;
  for (my $i = 0; $i < 9; ++$i) { $macros{"C$i"} = $ticket->{"c$i"}; }
  my $tmplcc = $tmpl;
  $tmpl =~ s/\(%\s*([A-Z0-9_]+)\s*%\)/$macros{$1}/g;
  $subject = "Ticket ".$ticket->{id};
  $subject .= ", ".$ticket->{subject} if $ticket->{subject} ne undef;
  TTXMail::sendmail(
   {
     to => $email,
     from => "\"".$cfg->get('company')."\" <".$cfg->get('email').">",
#     from => "\"".$cfg->get('company')."\" <" . (($cfg->get('_USER') ne undef && $cfg->get('_USER')->{email} ne undef)? $cfg->get('_USER')->{email}:$cfg->get('email')) . ">",
     subject => $subject,
     msg => $tmpl
   }
  );
  if ($cfg->get('emaillist') ne undef) {
    my $tmplname;
    if (@{$messages} == 1) {
      $tmplname = 'newccticket';
    } else {
      $tmplname = 'newccmessage';
    }
    if (open(TMPL, $cfg->get('basedir')."/templates/$tmplname.txt")) {
      my @buff = <TMPL>;
      close TMPL;
      $tmplcc = join('', @buff);
    }
    $macros{TICKETURL} = "http://$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}?cmd=ticket&key=".$ticket->{key}.
                         "\n\nACCESS KEY: ".$ticket->{key};
    my $n = $cfg->get('emaillist');
    if ($n =~ /^\d$/) {
      my @addrlist = split(/,/, $ticket->{"c$n"});
      $macros{UNAME} = 'Customer';
      foreach my $addr (@addrlist) {
        $addr =~ s/\s//g;
        $macros{UEMAIL} = $addr;
        my $tmpltmp = $tmplcc;
        $tmpltmp =~ s/\(%\s*([A-Z0-9_]+)\s*%\)/$macros{$1}/g;
        TTXMail::sendmail(
         {
           to => $addr,
           from => "\"".$cfg->get('company')."\" <".$cfg->get('email').">",
           subject => $subject,
           msg => $tmpltmp
         }
        );
      }
    }
  }
}
# ================================================================= buildadrlist

sub buildadrlist {
  my @adrlist;
  foreach my $oper (@{$_[0]}) {
    my $u = TTXUser->new($oper);
    if ($u ne undef && $u->{email} ne undef) {
      push @adrlist, $u->{email};
    }
  }
  return @adrlist;
}
# =============================================================== transfernotice

sub transfernotice {
  my $cfg = $_[0]->{cfg};
  my $ticket = $_[0]->{ticket};
  my $o = $cfg->get('_USER');
  return if $o eq undef;
  my $u = TTXUser->new($ticket->{oper});
  return if $u eq undef || $u->{email} eq undef;
  my $quicklink;
  if ($cfg->get('quicklink')) {
    $quicklink = '&o='.$ticket->{oper};
    my $salt = $ticket->{id} % 100;
    $salt = "0$salt" if $salt < 10;
    my $p = crypt($u->{passwd}.$ticket->{id}, $salt);
    $p =~ s/^\d\d//;
    $quicklink .= "&p=$p";
  }
  TTXMail::sendmail(
   {
     to => $u->{email},
     from => "\"".$cfg->get('company')."\" <".$cfg->get('email').">",
     subject => "Ticket transfer notice",
     msg => "Hello ".$u->{fname}.",\n\n".$o->{fname}." ".$o->{lname}." (".$o->{login}.") has transferred ".
            "trouble ticket #".$ticket->{id}." to you. In order to access the ticket use this link:\n\n".
            "http://$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}?cmd=helpdesk&tk=".$ticket->{key}."$quicklink\n\n"
   }
  );
}
# =================================================================== opernotify

sub opernotify {
  my $cfg = $_[0]->{cfg};
  my $ticket = $_[0]->{ticket};
  my @adrlist;
  if ($cfg->get('usegrpsel') && ! exists $_[0]->{notifylist}) {
    my $grp;
    if ($ticket->{grp} eq undef) {
      $grp = $cfg->get('defaultgrp');
    } else {
      $grp = $ticket->{grp};
    }
    my @list = split(/;/, $cfg->get("mbr-$grp"));
    $_[0]->{notifylist} = \@list;
  }
  if (exists $_[0]->{notifylist}) {
    @adrlist = buildadrlist($_[0]->{notifylist});
  } elsif ($ticket->{oper} ne undef) {
    my @operlist = split(/,/, $ticket->{oper});
    push @operlist, $cfg->get('supervisor') if $cfg->get('supervisor') ne undef;
    @adrlist = buildadrlist(\@operlist);
  } else {
    @adrlist = TTXUser::listemail();
  }
  my $email = $ticket->{'email'};
  my $name = $ticket->{'name'};
  my %macros;
  $name = 'Customer' if $name eq undef;
  my $subject;
  my $messages = $ticket->{messages};
  my $tmpl;
  if (@{$messages} == 1) {
    $tmpl = 'onewticket';
  } else {
    $tmpl = 'onewmessage';
  }
  if (open(TMPL, $cfg->get('basedir')."/templates/$tmpl.txt")) {
    my @buff = <TMPL>;
    close TMPL;
    $tmpl = join('', @buff);
  }
  $macros{TICKETID} = $ticket->{id};
  $macros{TICKETSTATE} = TTXCommon::status($ticket->{status});
  $macros{UNAME} = $name;
  $macros{COMPANYNAME} = $cfg->get('company');
  $macros{UEMAIL} = $email;
  $macros{TICKETURL} = "http://$ENV{HTTP_HOST}".$cfg->get('scriptname')."?cmd=helpdesk&tk=".$ticket->{key};
  my $msg = $messages->[@{$messages} - 1];
  my @msgparts = split(/\n\n/, $msg);
  shift @msgparts;
  my $body = join("\n\n", @msgparts);
  $body =~s/\[b]//g;
  $body =~s/:\[\/b]/:/g;
  $macros{MESSAGE} = $body;
  for (my $i = 0; $i < 9; ++$i) { $macros{"C$i"} = $ticket->{"c$i"}; }
  my $tmplcpy;
  my @oplist;
  if (!$cfg->get('quicklink')) {
    $tmpl =~ s/\(%\s*([A-Z0-9_]+)\s*%\)/$macros{$1}/g;
  } else {
    $tmplcpy = $tmpl;
    if (exists $_[0]->{notifylist}) {
      @oplist = @{$_[0]->{notifylist}};
    } elsif ($ticket->{oper} ne undef) {
      @oplist = split(/,/, $ticket->{oper});
      push @oplist, $cfg->get('supervisor') if $cfg->get('supervisor') ne undef;
    } else {
      @oplist = TTXUser::list();
    }
  }
  $subject = "Ticket ".$ticket->{id};
  $subject .= ", ".$ticket->{subject} if $ticket->{subject} ne undef;
  foreach my $adr (@adrlist) {
    if ($cfg->get('quicklink')) {
      my $oper = shift @oplist;
      if ($oper ne undef) { # just to make sure
        my $u = TTXUser->new($oper);
        if ($u ne undef && $u->{email} ne undef) {
          my $tmp = $macros{TICKETURL};
          $macros{TICKETURL} .= '&o='.$oper;
          my $salt = $ticket->{id} % 100;
          $salt = "0$salt" if $salt < 10;
          my $p = crypt($u->{passwd}.$ticket->{id}, $salt);
          $p =~ s/^\d\d//;
          $macros{TICKETURL} .= "&p=$p";
          $tmpl = $tmplcpy;
          $tmpl =~ s/\(%\s*([A-Z0-9_]+)\s*%\)/$macros{$1}/g;
          $macros{TICKETURL} = $tmp;
        } else {
          next;
        }
      } else {
        last;
      }
    }
    TTXMail::sendmail(
     {
       to => $adr,
       from => "\"".$cfg->get('company')."\" <".$cfg->get('email').">",
       subject => $subject,
       msg => $tmpl
     }
    );
  }
}
# ====================================================================== keyform

sub keyform {
  my ($cfg, $query, $data) = @_;
  $data->{PAGEHEADING} = 'Access Key';
  $data->{MESSAGE} = 'Forgot the key? We will send it to your email address.';
  return undef if !$query->param('do');
  $query->param(-name => 'do', -value => '');
  if ($query->param('cancel') ne undef) {
    if ($cfg->get('_USER') ne undef) { return 'helpdesk'; }
    else { return 'newticket'; }
  }
  if ($query->param('cmd') eq 'keyform') {
    my $key = TTXCommon::cleanit($query, 'key');
    if ($key eq undef) {
      $data->{ERROR_MESSAGE} = "Missing access key";
      return undef;
    }
    if ($cfg->get('shortkey')) {
      if ($key !~ /^\d+$/) {
        $data->{ERROR_MESSAGE} = "Invalid access key";
        return undef;
      }
    } elsif ($key !~ /^\d+Z\d+$/) {
      $data->{ERROR_MESSAGE} = "Invalid access key";
      return undef;
    }
    return 'ticket';
  }
# keyfinder code
  my $email = TTXCommon::cleanit($query, 'email');
  if ($email eq undef) {
    $data->{ERROR_MESSAGE} = "Missing email address";
    return undef;
  }
  if ($email !~ /^[0-9A-Za-z._-]+@[0-9A-Za-z_-]+\.[0-9A-Za-z._-]+$/) {
    $data->{ERROR_MESSAGE} = "Invalid email address";
    return undef;
  }
  my $tickets = TTXCommon::dbtik();
  if ($tickets eq undef || $tickets->error() ne undef) {
    $data->{ERROR_MESSAGE} = $tickets->errortext();
    return undef;
  }
  my @filter;
  my $f;
  $f->{col} = 'email';
  $f->{expr} = "^$email\$";
  push @filter, $f;
  my $browser = $tickets->list(0, 999, 'id', 'A', \@filter);
  my $list = $browser->{list};
  if (@{$list} < 1) {
    $data->{ERROR_MESSAGE} = "No tickets found";
  } else {
    my $body;
    foreach my $id (@{$list}) {
      my $t = $tickets->ticket($id);
      $body .= "#".$id." (".$t->{subject}.") KEY: ".$t->{key}."\n";
    }
    $tickets = undef;
    $body = "Dear customer,\n\nBelow is a list of all service tickets associated ".
            "with your email address\n\n$body\n";
    $body .= "Use the following link to access your tickets:\n".
             "http://$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}?cmd=ticket\n\n".
             "Kind Regards\n".$cfg->get('company')."\n";
    TTXMail::sendmail(
     {
       to => $email,
       from => "\"".$cfg->get('company')."\" <".$cfg->get('email').">",
       subject => "Access key(s)",
       msg => $body
     }
    );
    $data->{MESSAGE} = '<b>Access keys were sent to your email address.</b>';
  }
  return undef;
}
# ================================================================== checkgroups
my $groupsenabled;
sub checkgroups {
  if ($groupsenabled eq undef) {
    eval "use TTXGroups";
    if (!$@) {
      $groupsenabled = 1;
    } else {
      $groupsenabled = 0;
      if ($_[0]->get('usegrpsel')) {
        $_[0]->set('usegrpsel', 0);
        $_[0]->save();
      }
    }
  }
}
# ==================================================================== newticket

sub newticket {
  my ($cfg, $query, $data) = @_;
  $data->{PAGEHEADING} = 'Contact Customer Service';
  if (TTXData::get('ISPRO')) {
    $data->{FILEFORMS} = TTXFile::fileforms();
  }
  if ($cfg->get('_USER') ne undef) {
    $data->{INTERNALCHECKBOX} = '<input type=checkbox name=internal value=1' .
       ($query->param('internal') ? ' checked':''). '> <span class=lbl>Internal</span>';
  } else {
    $data->{INTERNALCHECKBOX} = '&nbsp;';
  }
  checkgroups($cfg);
  if ($cfg->get('usegrpsel')) {
    TTXGroups::selector($cfg, $query, $data);
  }
  return undef if !$query->param('do');
  $query->param(-name => 'do', -value => '');
  if ($query->param('cancel') ne undef) {
    $query->param(-name => 'cancel', -value => '');
    if ($cfg->get('_USER') ne undef) {
      $query->param(-name => 'tid', -value=> '');
      return 'helpdesk';
    } else {
      return undef;
    }
  }
  my $ticket;
  $ticket->{grp} = TTXCommon::cleanit($query, 'grp');
  $ticket->{name} = TTXCommon::cleanit($query, 'name');
  $ticket->{email} = TTXCommon::cleanit($query, 'email');
  $ticket->{subject} = TTXCommon::cleanit($query, 'subject');
  my $error;
  if ($ticket->{name} eq undef) {
    $error .= "Missing Name<br>";
  }
  $ticket->{lname} = $ticket->{name};
  $ticket->{name} =~ /\s(\w+)$/;
  $ticket->{lname} = $1 if $1 ne undef;
  if ($ticket->{email} eq undef) {
    $error .= "Missing Email<br>\n";
  } elsif ($ticket->{email} !~ /^[0-9A-Za-z._-]+@[0-9A-Za-z_-]+\.[0-9A-Za-z._-]+$/) {
    $error .= "Invalid Email<br>";
  }
  if ($ticket->{grp} eq undef && $cfg->get('usegrpsel')) {
    $error .= "Missing ".($cfg->get('grpsellbl') || 'Department')."<br>";
  }
  if ($ticket->{subject} eq undef) {
    $error .= "Missing Subject<br>";
  }
  my $custom;
  my @inputs = sort $query->param();
  my @mandatory = $query->param('mandatory');
  foreach my $input (@inputs) {
    next if $input !~ /^x./;
    if ($query->param($input) eq undef) {
      if (grep(/\b$input\b/, @mandatory)) {
        $input =~ s/^x//;
        $error .= "Missing $input<br>\n";
      }
      next;
    }
    my $val = $query->param($input);
    if ($cfg->get($input) ne undef) {
      my $cidx = int ($cfg->get($input));
      if ($cidx >= 0 && $cidx < 10) {
        $ticket->{"c$cidx"} = $val;
      }
    }
    $input =~ s/^x//;
    $custom .= "[b]$input:[/b] $val\n";
  }
  $custom .= "\n" if $custom ne undef;
  if ($error ne undef) {
    $error =~ s/<br>$//;
    $data->{ERROR_MESSAGE} = $error;
    return undef;
  }
  TTXCommon::cleanit($query, 'problem');
  my $tickets = TTXCommon::dbtik();
  if ($tickets->error() ne undef || !$tickets->addticket($ticket)) {
    $data->{ERROR_MESSAGE} = $tickets->errortext();
    return undef;
  }
  if ($cfg->get('validate') ne undef) {
    my $n = $cfg->get('validate');
    if ($n =~ /^\d$/) {
      $ticket->{"c$n"} = 'N';
      srand($ticket->{open});
      my $k = int (rand(999999));
      $data->{VALIDATIONCODE} = $ticket->{id}."Z$k";
    }
  }
  my @messages;
  $messages[0] = "From: ".$ticket->{name}."\nDate: ".time()."\n";
  if ($query->param('internal')) {
     $messages[0] .= "Operator: 1\nInternal: Yes\n";
  }
  if (TTXData::get('ISPRO')) {
    for (my $i = 1; $i < 4; ++$i) {
      next if $query->param("f$i") eq undef;
      $messages[0] .= TTXFile::addfile($query, "f$i", "fname$i", $ticket->{id});
    }
  }
  $messages[0] .= "\n$custom".substr($query->param('problem'),0,32*1024);
  $ticket->{messages} = \@messages;
  if (!$tickets->save()) {
    $data->{ERROR_MESSAGE} = $tickets->errortext();
    return undef;
  }
  $tickets = undef;
  $data->{TICKETID} = $ticket->{id};
  $data->{TICKETKEY} = $ticket->{key};
  usernotify({cfg => $cfg, ticket => $ticket, validationcode => $data->{VALIDATIONCODE}})
    if !$query->param('internal');
  if ($cfg->get('validate') eq undef) {
    my $opernotifydata = {cfg => $cfg, ticket => $ticket};
    if ($cfg->get('supervisor') ne undef) {
      my @list = ($cfg->get('supervisor'));
      $opernotifydata->{notifylist} = \@list;
    } elsif ($cfg->get('usegrpsel')) {
      my @list = split(/;/, $cfg->get("mbr-".$ticket->{grp}));
      $opernotifydata->{notifylist} = \@list;
    } elsif ($cfg->get('routex') ne undef) {
      eval "use TTXCustomRoute";
      if ($@ eq undef) {
        my @list = TTXCustomRoute::routelist($cfg, $ticket);
        $opernotifydata->{notifylist} = \@list;
      }
    }
    opernotify($opernotifydata);
  }
  if ($cfg->get('internaldesk')) {
    $query->param(-name => 'reset', -value => 1);
    return 'helpdesk';
  }
  return 'confirmnew';
}
# =================================================================== confirmnew

sub confirmnew {
  my ($cfg, $query, $data) = @_;
  return undef;
}
# ==================================================================== fid2title
my $_f2t;
sub fid2title {
 if ($_f2t eq undef) {
   eval 'use TTXData';
   my $cfg;
   eval '$cfg = TTXData::get'."('CONFIG')";
   return $_[0] if $cfg eq undef;
   my @xflds = grep(/^x/, $cfg->vars());
   foreach my $xfld (@xflds) {
     my $t = $xfld;
     $t =~ s/^x//;
     $_f2t->{'c'.$cfg->get($xfld)} = $t;
   }
 }
 return $_f2t->{$_[0]} || $_[0];
}
# ======================================================================= wanted

sub wanted {
  my ($cfg, $query, $ticket) = @_;
  my $buff;
  if ($cfg->get('mandatoryfields') ne undef) {
    my @mflist = split(/;/, $cfg->get('mandatoryfields'));
    foreach my $fid (@mflist) {
      next if $fid !~ /^c\d+$/;
      my $title = fid2title($fid);
      $title =~ s/</&lt;/g;
      $buff .= "<tr>\n<td align=left class=lbl>$title</td>\n<td align=left>";
      my $id = $fid; $id =~ s/^c//;
      if ($cfg->get("dropdown$id") ne undef) {
        $buff .= "<select name=wanted$id>\n";
        if ($ticket->{$fid} eq undef) {
          if ($query->param("wanted$id") eq undef) {
            $buff .= "<option></option>\n";
          }
        } elsif ($query->param("wanted$id") eq undef) {
          $query->param(-name => "wanted$id", -value => $ticket->{$fid});
        }
        my @options = split(/;/, $cfg->get("dropdown$id"));
        foreach my $option (@options) {
          my $safeoption1 = $option;
          my $safeoption2 = $option;
          $safeoption1 =~ s/"/&quot/g;
          $safeoption2 =~ s/</&lt;/g;
          $buff .= "<option value=\"$safeoption1\"";
          if ($option eq $query->param("wanted$id")) {
            $buff .= ' selected';
          }
          $buff .= ">$safeoption2</option>\n";
        }
        $buff .= "</select>\n";
      } else {
        my $val = $query->param('do') ? $query->param("wanted$id") : $ticket->{$fid};
        $val =~ s/"/&quot;/g;
        $buff .= "<input type=text size=25 name=wanted$id value=\"$val\">\n";
      }
      $buff .= "</td>\n</tr>\n";
    }
    if ($buff ne undef) {
      $buff = "<table width=".$cfg->get('HTMLBASEWIDTH')."cellspacing=0 cellpadding=0 bgcolor=\"#CFDCE8\">\n".
              "<tr>\n<td align=center>\n".
              "<table cellpadding=3>$buff</table>\n".
              "</td>\n</tr>\n".
              "</table>\n";
    }
  }
  return $buff;
}
# ======================================================================= lockdb
my $lockcnt;
sub lockdb {
  return ++$lockcnt if $lockcnt;
  my $cfg = TTXData::get('CONFIG');
  return 1 if $cfg->get('dbmode') !~ /sql/;
  my $lockfile = $cfg->get('basedir')."/lockdb.ttx";
  if (! -f $lockfile) {
    if (!open(LOCK, ">$lockfile")) {
      return 0;
    }
  } elsif (!open(LOCK,"+<$lockfile")) {
    return 0;
  }
  flock(LOCK, 2);
  $lockcnt = 1;
  return 1;
}
# ===================================================================== unlockdb

sub unlockdb {
  return if !$lockcnt;
  my $cfg = TTXData::get('CONFIG');
  return if $cfg->get('dbmode') !~ /sql/;
  --$lockcnt;
  if (!$lockcnt) {
    flock(LOCK, 8);
    close LOCK;
  }
}
# ======================================================================== claim

sub claim {
  my ($cfg, $query, $data) = @_;
  if ($query->param('cancel') ne undef) {
    $query->param(-name => 'tid', -value=> '');
    $query->param(-name => 'do', -value => '');
    return 'helpdesk';
  }
  return undef if !$query->param('do');
  $query->param(-name => 'do', -value => '');
  lockdb();
  my $tickets = TTXCommon::dbtik();
  if ($tickets eq undef || $tickets->error() ne undef) {
    $data->{ERROR_MESSAGE} = $tickets->errortext();
    unlockdb();
    return undef;
  }
  my $t = $tickets->ticketbykey(TTXCommon::cleanit($query, 'key'));
  if ($t eq undef) {
    $data->{ERROR_MESSAGE} = 'Invalid access key';
    $query->param(-name => 'tid', -value=> '');
    unlockdb();
    return 'helpdesk';
  }
  if ($t->{oper} ne undef) {
    $data->{ERROR_MESSAGE} = "The ticket is already assigned to ".$t->{oper};
  } else {
    if ($cfg->get('mandatoryfields') ne undef && $query->param('delete') eq undef) {
      my @mflist = split(/;/, $cfg->get('mandatoryfields'));
      my $err;
      foreach my $fid (@mflist) {
        next if $fid !~ /^c\d+$/;
        my $id = $fid; $id =~ s/^c//;
        if ($query->param("wanted$id") ne undef) {
          $t->{$fid} = $query->param("wanted$id");
        } elsif ($t->{$fid} eq undef) {
          $err .= "Missing ".fid2title($fid)."<br>";
        }
      }
      if ($err ne undef) {
        $data->{ERROR_MESSAGE} = $err;
        $data->{WANTED} = wanted($cfg, $query, $t);
        unlockdb();
        return 'ticket';
      }
    }
    $t->{oper} = $cfg->get('_USER')->get('login');
    $t->{status} = 'OPN';
    if ($cfg->get('claimtime') ne undef) {
      my $totaltm = int ((time() - $t->{open})/60);
      my $totaltmm = $totaltm % 60;
      my $totaltmh = int(($totaltm - $totaltmm) / 60);
      $totaltmm = "0$totaltmm" if $totaltmm < 10;
      $totaltmh = "0$totaltmh" if $totaltmh < 10;
      $t->{'c'.$cfg->get('claimtime')} = $totaltmh.':'.$totaltmm;
    }
    $tickets->save();
    TTXCommon::logit("CLAIM|".$t->{oper}."|".$t->{id});
    if ($query->param('delete') ne undef) {
      if (!$cfg->get('demo') || $cfg->get('_USER')->{login} eq 'admin') {
        $tickets->deltik($t->{id});
        $tickets->save();
      }
      $query->param(-name => 'tid', -value=> '');
      unlockdb();
      return 'helpdesk';
    }
  }
  unlockdb();
  return 'ticket';
}
# ======================================================================= ticket

sub ticket {
  my ($cfg, $query, $data) = @_;
  checkgroups($cfg);
  TTXCommon::tickedvars($cfg, $data);
  if ($query->param('cancel') ne undef) {
    if ($query->param('sid') ne undef) {
      $query->param(-name => 'tid', -value=> '');
      $query->param(-name => 'do', -value=> '');
      return 'helpdesk';
    } else {
      if ($query->param('emailkey') ne undef) {
        return 'mytickets';
      } else {
        return 'newticket';
      }
    }
  }
  if ($query->param('key') eq undef) {
    return 'keyform';
  }
  my $tickets = TTXCommon::dbtik();
  if ($tickets eq undef || $tickets->error() ne undef) {
    $data->{ERROR_MESSAGE} = $tickets->errortext();
    return undef;
  }
  my $t = $tickets->ticketbykey(TTXCommon::cleanit($query, 'key'));
  if ($t eq undef) {
    $data->{ERROR_MESSAGE} = $cfg->get('shortkey') ? 'Ticket does not exist':'Invalid access key';
    return 'keyform';
  }
  $query->param(-name => 'tid', -value=> $t->{id});
  my $cmd;
  my $isoper = 0;
  if ($cfg->get('_USER') ne undef) {
    if ($t->{oper} eq undef) {
      $cmd = 'claim';
      $data->{WANTED} = wanted($cfg, $query, $t);
      $data->{DELTICKET} = "&nbsp;&nbsp;<input type=submit onsubmit name=delete onclick=\"return confirmdel()\" value=\"Delete ticket\">";
    } else {
      $data->{DELTICKET} = "<input type=submit onsubmit name=delete onclick=\"return confirmdel()\" value=\"Delete ticket\">";
    }
    $isoper = 1;
    $data->{TICKEDOPEN} = "<a href=# onClick=\"return ticked('".$query->param('tid')."')\">";
    $data->{TICKEDCLOSE} = '</a>';
    $data->{ANSWERLIB} = '&nbsp;&nbsp;&nbsp;&nbsp;<a href=#teditor onClick="return answerlib()">Answer library</a>';
  }
  if ($query->param('do') && $t->{status} eq 'CLS' && !$isoper) {
    $query->param(-name => 'email', -value => $t->{email});
    $query->param(-name => 'name', -value => $t->{name});
    $query->param(-name => 'subject', -value => $t->{subject});
    $query->param(-name => 'problem', -value => "Posted as a followup to the solved ticket #".$t->{id}.
                                                ".\n\n".$query->param('problem'));
    return 'newticket';
  }
  my $notify;
  my $xupdate = 0;
  my @inputs = $query->param();
  @inputs = grep(/^x/, @inputs);
  foreach my $input (@inputs) {
    my $val = TTXCommon::cleanit($query, $input);
    my $n = $cfg->get($input);
    next if $n eq undef || $n =~ /[^0-9]/ || $n < 0 || $n > 9;
    if ($val ne $t->{"c$n"}) {
      $t->{"c$n"} = $val;
      $xupdate = 1;
    }
  }
  if ($cmd eq undef && $query->param('do')) {
    if ($isoper && $query->param('delete') ne undef) {
      if (!$cfg->get('demo') || $cfg->get('_USER')->{login} eq 'admin') {
        $tickets->deltik($t->{id});
        $tickets->save();
      }
      $query->param(-name => 'do', -value=> '');
      $query->param(-name => 'tid', -value=> '');
      return 'helpdesk';
    }
    my $attachment;
    if (TTXData::get('ISPRO')) {
      for (my $i = 1; $i < 4; ++$i) {
        next if $query->param("f$i") eq undef;
        $attachment .= TTXFile::addfile($query, "f$i", "fname$i", $t->{id});
      }
    }
    if ($query->param('problem') eq undef && $attachment ne undef) {
      $query->param(-name => 'problem', -value => 'See attachment');
    }
    if ($query->param('problem') eq undef && $query->param('newstatus') eq 'CLS') {
      $query->param(-name => 'problem', -value => 'Ticket closed');
    }
    if ($query->param('problem') eq undef &&
        ($query->param('newstatus') eq undef || $t->{status} eq $query->param('newstatus')) &&
        ($query->param('transfer') eq undef || $t->{oper} eq $query->param('transfer')) &&
        !$xupdate) {
      $data->{ERROR_MESSAGE} = 'Missing message';
    } elsif (!$isoper && $cfg->get('askforname') && TTXCommon::cleanit($query, 'respondername') eq undef) {
      $data->{ERROR_MESSAGE} = 'Missing name';
    } else {
      if ($isoper && $cfg->get('tracktime') ne undef) {
        my $ttx = $cfg->get('tracktime');
        if ($ttx !~ /[^0-9]/ && $ttx >= 0 && $ttx < 10) {
          my $tth = int(TTXCommon::cleanit($query, 'tracktimeh'));
          my $ttm = int(TTXCommon::cleanit($query, 'tracktimem'));
          $query->param(-name => 'tracktimeh', -value => '');
          $query->param(-name => 'tracktimem', -value => '');
          my ($totaltmh, $totaltmm) = split(/:/, $t->{"c$ttx"});
          my $totaltm = $totaltmh * 60 + $totaltmm;
          $totaltm += $tth * 60 + $ttm;
          $totaltmm = $totaltm % 60;
          $totaltmh = int(($totaltm - $totaltmm) / 60);
          $totaltmm = "0$totaltmm" if $totaltmm < 10;
          $totaltmh = "0$totaltmh" if $totaltmh < 10;
          $t->{"c$ttx"} = $totaltmh.':'.$totaltmm;
        }
      }
      if ($query->param('newstatus') ne undef) {
        $t->{status} = $query->param('newstatus');
      } else {
        if ($t->{status} eq 'OPN' && $isoper && !$query->param('internal')) { $t->{status} = 'WFR'; }
        if ($t->{status} eq 'WFR' && !$isoper) { $t->{status} = 'OPN'; }
      }
      if ($query->param('problem') ne undef || $attachment ne undef) {
        my $unm = $t->{name};
        if ($cfg->get('askforname')) {
          $unm = $query->param('respondername');
        }
        my $msg = "From: ".($isoper ? $cfg->get('_USER')->get('login') : $unm)."\nDate: ".time()."\nOperator: $isoper\n";
        if ($isoper && $query->param('internal')) {
          $msg .= "Internal: Yes\n";
        }
        $msg .= "$attachment\n".substr($query->param('problem'),0,32*1024);
        push @{$t->{messages}}, $msg;
        $query->param(-name => 'problem', -value => '');
        $notify = 1;
        if ($isoper) {
          TTXCommon::logit("RESPOND|".$t->{oper}."|".$t->{id});
        }
      }
      if ($isoper && $query->param('transfer') ne undef && $query->param('transfer') ne $t->{oper}) {
        TTXCommon::logit("TRANSFER|".$t->{oper}."|".$t->{id}."|".$query->param('transfer'));
        if ($query->param('transfer') !~ /^\+/) {
          $t->{oper} = $query->param('transfer');
          $t->{status} = 'OPN' if $cfg->get('transferopens');
          transfernotice({cfg => $cfg, ticket => $t});
        } elsif($cfg->get('usegrpsel')) {
          $t->{grp} = $query->param('transfer');
          TTXGroups::grptransfer({cfg => $cfg, ticket => $t});
        }
      }
      $t->{updated} = time();
      if ($t->{status} eq 'CLS') {
        $t->{closed} = $t->{updated};
        if ($isoper) {
          TTXCommon::logit("CLOSE|".$t->{oper}."|".$t->{id});
        }
      }
      $tickets->save();
      if ($t->{status} eq 'PND' && $isoper) {
        $query->param(-name => 'do', -value => '');
#        $query->param(-name => 'tid', -value => $t->{id});
        $data->{DELTICKET} = "&nbsp;&nbsp;<input type=submit onsubmit name=delete onclick=\"return confirmdel()\" value=\"Delete ticket\">";
#        usernotify({cfg => $cfg, ticket => $t}) if $notify && !($isoper && $query->param('internal'));
          $cmd = 'claim';
      }
    }
  }
  $tickets = undef;
  if (($t->{status} eq 'WFR' || $t->{status} eq 'CLS') && $isoper) {
    $data->{NEWSTATUS} = "<input type=radio name=newstatus value=OPN";
    if ($query->param('newstatus') eq 'OPN') { $data->{NEWSTATUS} .= ' checked'; }
    $data->{NEWSTATUS} .= "> Open<br>\n";
  }
  if ($t->{status} eq 'OPN') {
    $data->{NEWSTATUS} .= "<input type=radio name=newstatus value=WFR";
    if ($query->param('newstatus') eq 'WFR') { $data->{NEWSTATUS} .= ' checked'; }
    $data->{NEWSTATUS} .= "> Responded<br>\n";
  }
  if ($t->{status} ne 'CLS') {
    $data->{NEWSTATUS} .= "<input type=radio name=newstatus value=CLS";
    if ($query->param('newstatus') eq 'CLS') { $data->{NEWSTATUS} .= ' checked'; }
    $data->{NEWSTATUS} .= "> Closed<br>\n";
  }
  if ($isoper) {
    $data->{NEWSTATUS} .= '<br><input type=checkbox name=internal value=1';
    if ($query->param('internal')) {
      $data->{NEWSTATUS} .= ' checked';
    }
    $data->{NEWSTATUS} .= '> <span class=lbl>Internal</span><br>';
  }
  if ($isoper && $cfg->get('_USER')->{login} eq $t->{oper}) {
    my @operlist = TTXUser::list();
    if (@operlist > 1) {
      $data->{NEWSTATUS} .= "<br><table cellpadding=0 cellspacing=0><tr><td align=right><span class=lbl>Transfer to</span></td></tr>\n".
                            "<tr><td align=right><br class=tiny><select name=transfer>\n";
      $data->{NEWSTATUS} .= "<option></option>\n";
      foreach my $oper (@operlist) {
        next if $oper eq $cfg->get('_USER')->{login};
        $data->{NEWSTATUS} .= "<option value=$oper";
        if ($query->param('transfer') eq $oper) {
          $data->{NEWSTATUS} .= " selected";
        }
        $data->{NEWSTATUS} .= ">$oper</option>\n";
      }
      if ($cfg->get('usegrpsel')) {
        TTXGroups::trselector($cfg, $data);
      }
      $data->{NEWSTATUS} .= "</select></td></tr></table>\n";
    }
  }
  $data->{PAGEHEADING} = "Ticket #".$t->{id};
  $data->{TICKET_status} = TTXCommon::status($t->{status});
  $data->{TICKET_subject} = $t->{subject};
  $data->{TICKET_email} = $t->{email};
  $data->{TICKET_name} = $t->{name};
  $data->{TICKET_key} = $t->{key};
  $data->{TICKET_open} = TTXCommon::tmtxt($t->{open});
  $data->{TICKET_GROUP} = $cfg->get($t->{grp}) || '-';
  $data->{TICKET_closed} = $t->{status} eq 'CLS' ? TTXCommon::tmtxt($t->{closed}):'-';
  $data->{TICKET_oper} = $isoper ? $t->{oper}:(($t->{oper} eq undef) ? 'not assigned':'assigned');
  my @xvars = $cfg->vars();
  @xvars = grep(/^x/, @xvars);
  foreach my $xvar (@xvars) {
    $data->{'TICKET_c'.$cfg->get($xvar)} = $t->{'c'.$cfg->get($xvar)};
    if ($query->param('do') eq undef) {
      $query->param(-name => $xvar, -value => $t->{'c'.$cfg->get($xvar)});
    }
  }
  if ($cfg->get('tracktime') ne undef && $isoper) {
    my $ttx = $cfg->get('tracktime');
    if ($ttx !~ /[^0-9]/ && $ttx >= 0 && $ttx < 10) {
      my $tth = TTXCommon::cleanit($query, 'tracktimeh');
      my $ttm = TTXCommon::cleanit($query, 'tracktimem');
      $tth =~ s/"/&quot;/g; $ttm =~ s/"/&quot;/g;
      $data->{TRACKTIME} = "<b>Time spent on preparing the response (hh:mm)</b>\n".
                           "<input type=text size=2 name=tracktimeh value=\"$tth\">:".
                           "<input type=text size=2 name=tracktimem value=\"$ttm\"><br><br class=tiny>";
    }
  }
  if (!$isoper && $cfg->get('askforname')) {
    if ($query->param('emailkey') ne undef && $query->param('emailkey') eq $t->{email}) {
      if ($query->param('respondername') eq undef) {
        $query->param(-name => 'respondername', -value => $t->{name});
      }
    }
    my $nm = $query->param('respondername');
    $nm =~ s/"/&quot;/g;
    $data->{TRACKTIME} .= "<b>Your name:</b>&nbsp;&nbsp;\n".
                          "<input type=text size=25 name=respondername value=\"$nm\"><br><br class=tiny>";
  }
  my %images;
  my %names;
  foreach my $msg (@{$t->{messages}}) {
    my @msgparts = split(/\n\n/, $msg);
    my $rawheader = shift @msgparts;
    my $body = join("\n\n", @msgparts);
    my @headerlines = split(/\n/, $rawheader);
    chomp @headerlines;
    my %header;
    foreach my $line (@headerlines) {
      if ($line =~ /^([a-zA-Z][a-zA-Z0-9-]*):\s*(.*)$/) {
        $header{uc $1} = $2;
      }
    }
    next if $header{OPERATOR} && $header{INTERNAL} =~ /Yes/ && !$isoper;
    my $style;
    if ($header{OPERATOR}) {
      if ($header{INTERNAL} =~ /Yes/) {
        $style = 'imsg';
      } else {
        $style = 'omsg'
      }
    } else {
      $style = 'cmsg';
    }
    my $imgtag;
    my $fromtag;
    if ($header{OPERATOR}) {
      if (!exists $images{$header{FROM}}) {
        my $u = TTXUser->new($header{FROM});
        if ($u eq undef) {
          $images{$header{FROM}} = undef;
          $names{$header{FROM}} = undef;
        } else {
          $images{$header{FROM}} = $u->{image};
          $names{$header{FROM}} = $u->{fname}.' '.$u->{lname};
        }
      }
      if ($images{$header{FROM}} ne undef) {
        $imgtag = "<br><br class=sm><center><nobr>&nbsp;<img src=\"$images{$header{FROM}}\">&nbsp;</nobr></center><br class=sm>\n";
      }
      $fromtag = $names{$header{FROM}};
      if ($isoper) { $fromtag .= " ($header{FROM})"; }
    }
    $fromtag = $header{FROM} if $fromtag eq undef;
    $fromtag =~ s/</&lt;/g;
    $data->{MESSAGES} .= "<tr>\n<td width=20% align=left valign=top class=$style>$fromtag<br>".TTXCommon::tmtxt($header{DATE})."$imgtag</td>\n";
    $body =~ s/</&lt;/g;
    $body = TTXMarkup::html($body);
    $body =~ s/\n/<br>\n/g;
    my $firstfile = 1;
    for (my $i=1; $i < 4; ++$i) {
      if ($header{"FILE$i"} ne undef) {
        if ($firstfile) {
          $body .= "<br class=sm><br class=sm>Attachments:<br>\n";
          $firstfile = 0;
        }
        $header{"FILE$i"} =~ s/CGIURL/$ENV{SCRIPT_NAME}/;
        $body .= $header{"FILE$i"} . "<br>\n";
      }
    }
    $data->{MESSAGES} .= "<td align=left valign=top class=$style>$body</td>\n</tr>\n";
  }
  if (TTXData::get('ISPRO')) {
    $data->{FILEFORMS} = TTXFile::fileforms();
  }
  if ($notify) {
    usernotify({cfg => $cfg, ticket => $t,
                from => $isoper ?
                  $cfg->get('_USER')->{fname}.' '.$cfg->get('_USER')->{lname} :
                  $query->param('respondername')})
      if !($isoper && $query->param('internal'));
    if (!$isoper) {
      if ($t->{status} eq 'PND') {
        if ($cfg->get('validate') eq undef || $t->{'c'.$cfg->get('validate')} eq 'Y') {
          my $opernotifydata = {cfg => $cfg, ticket => $t};
          if ($cfg->get('supervisor') ne undef) {
            my @list = ($cfg->get('supervisor'));
            $opernotifydata->{notifylist} = \@list;
          } elsif ($cfg->get('usegrpsel')) {
            my @list = split(/;/, $cfg->get("mbr-".$t->{grp}));
            $opernotifydata->{notifylist} = \@list;
          } elsif ($cfg->get('routex') ne undef) {
            eval "use TTXCustomRoute";
            if ($@ eq undef) {
              my @list = TTXCustomRoute::routelist($cfg, $t);
              $opernotifydata->{notifylist} = \@list;
            }
          }
          opernotify($opernotifydata);
        }
      } else {
        opernotify({cfg => $cfg, ticket => $t});
      }
    } elsif ($t->{oper} ne undef && $cfg->get('_USER')->{login} ne $t->{oper}) {
      opernotify({cfg => $cfg, ticket => $t});
    }
  }
  return $cmd;
}


1;
#
